#ifdef GL_ES                                
precision lowp float;                        
#endif                                        

uniform sampler2D u_texture;

uniform vec2 texture_size;

uniform float edge_size;
uniform float shadow_size;
uniform vec3 color;

varying vec4 v_fragmentColor;                
varying vec2 v_texCoord;


int getIsStrokeWithAngel(vec2 texCoord, vec2 unit, float angel)
{
    float rad = angel * 0.01745329252; // 这个浮点数是 pi / 180，角度转弧度
    
    // 本身的
    if (texture2D(u_texture, texCoord).a > 0.5)
    {
        return 1;
    }
    
    vec2 offset = vec2(cos(rad) * unit.x, sin(rad) * unit.y);
    
    // 描边
    vec2 edge_offset = offset * edge_size;
    if (texture2D(CC_Texture0, texCoord + edge_offset).a > 0.5)
    {
        return 1;
    }
    
    // 投影
    vec2 shadow_offset = edge_offset + vec2(0.0, shadow_size) * unit.y;
    if (texture2D(CC_Texture0, texCoord + shadow_offset).a > 0.5)
    {
        return 1;
    }
    
    return 0;
}

void main()                                    
{
    vec4 texColor = vec4(0.0, 0.0, 0.0, 0.0);
    
    //单位坐标
    vec2 unit = 1.0 / texture_size.xy;
    // 转换后的位置
    vec2 texCoord = v_texCoord - (vec2(edge_size, edge_size + shadow_size)) * unit;
    
    int strokeCount = 0;
    strokeCount += getIsStrokeWithAngel(texCoord, unit, 0.0);
    strokeCount += getIsStrokeWithAngel(texCoord, unit, 10.0);
    strokeCount += getIsStrokeWithAngel(texCoord, unit, 20.0);
    strokeCount += getIsStrokeWithAngel(texCoord, unit, 30.0);
    strokeCount += getIsStrokeWithAngel(texCoord, unit, 40.0);
    strokeCount += getIsStrokeWithAngel(texCoord, unit, 50.0);
    strokeCount += getIsStrokeWithAngel(texCoord, unit, 60.0);
    strokeCount += getIsStrokeWithAngel(texCoord, unit, 70.0);
    strokeCount += getIsStrokeWithAngel(texCoord, unit, 80.0);
    strokeCount += getIsStrokeWithAngel(texCoord, unit, 90.0);
    strokeCount += getIsStrokeWithAngel(texCoord, unit, 100.0);
    strokeCount += getIsStrokeWithAngel(texCoord, unit, 110.0);
    strokeCount += getIsStrokeWithAngel(texCoord, unit, 120.0);
    strokeCount += getIsStrokeWithAngel(texCoord, unit, 130.0);
    strokeCount += getIsStrokeWithAngel(texCoord, unit, 140.0);
    strokeCount += getIsStrokeWithAngel(texCoord, unit, 150.0);
    strokeCount += getIsStrokeWithAngel(texCoord, unit, 160.0);
    strokeCount += getIsStrokeWithAngel(texCoord, unit, 170.0);
    strokeCount += getIsStrokeWithAngel(texCoord, unit, 180.0);
    strokeCount += getIsStrokeWithAngel(texCoord, unit, 190.0);
    strokeCount += getIsStrokeWithAngel(texCoord, unit, 200.0);
    strokeCount += getIsStrokeWithAngel(texCoord, unit, 210.0);
    strokeCount += getIsStrokeWithAngel(texCoord, unit, 220.0);
    strokeCount += getIsStrokeWithAngel(texCoord, unit, 230.0);
    strokeCount += getIsStrokeWithAngel(texCoord, unit, 240.0);
    strokeCount += getIsStrokeWithAngel(texCoord, unit, 250.0);
    strokeCount += getIsStrokeWithAngel(texCoord, unit, 260.0);
    strokeCount += getIsStrokeWithAngel(texCoord, unit, 270.0);
    strokeCount += getIsStrokeWithAngel(texCoord, unit, 280.0);
    strokeCount += getIsStrokeWithAngel(texCoord, unit, 290.0);
    strokeCount += getIsStrokeWithAngel(texCoord, unit, 300.0);
    strokeCount += getIsStrokeWithAngel(texCoord, unit, 310.0);
    strokeCount += getIsStrokeWithAngel(texCoord, unit, 320.0);
    strokeCount += getIsStrokeWithAngel(texCoord, unit, 330.0);
    strokeCount += getIsStrokeWithAngel(texCoord, unit, 340.0);
    strokeCount += getIsStrokeWithAngel(texCoord, unit, 350.0);

    if (strokeCount > 0)
    {
        texColor = vec4(color, 1.0);
    }
    
    gl_FragColor = v_fragmentColor * texColor;
}
